Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPicSym.cpp	(revision 75)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPicSym.cpp	(revision 76)
@@ -185,5 +185,5 @@
   {
     m_apcTComSlice[m_uiNumAllocatedSlice-1]->copySliceInfo( m_apcTComSlice[m_uiNumAllocatedSlice-2] );
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
     m_apcTComSlice[m_uiNumAllocatedSlice-1]->initSlice( m_apcTComSlice[m_uiNumAllocatedSlice-1]->getLayerId() );
 #else
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.cpp	(revision 75)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.cpp	(revision 76)
@@ -140,5 +140,5 @@
 
 
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
 Void TComSlice::initSlice( UInt layerId )
 #else
@@ -146,5 +146,5 @@
 #endif
 {
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
   m_layerId = layerId;
 #endif
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.h	(revision 75)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComSlice.h	(revision 76)
@@ -1344,5 +1344,5 @@
   TComSlice();
   virtual ~TComSlice(); 
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
   Void      initSlice       ( UInt layerId );
 #else
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h	(revision 75)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h	(revision 76)
@@ -49,6 +49,4 @@
 #define SVC_UPSAMPLING                   1      ///< upsampling filters
 #define PHASE_DERIVATION_IN_INTEGER      1      ///< upsampling filters implementation using only integer arithmetic
-#define SET_SLICE_LAYER_ID               1      ///< set layerId to the slice
-#define BUGFIX_925                       1      ///< bug fix ticket #925
 #define ENCODER_BUGFIX                   1      ///< L0167: encoder bug fix for inter mode
 #define CHROMA_UPSAMPLING                1      ///< L0335: Chroma upsampling with 5 bits coefficients
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.cpp	(revision 75)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.cpp	(revision 76)
@@ -334,5 +334,5 @@
   cFillSlice.setSPS( m_parameterSetManagerDecoder.getFirstSPS() );
   cFillSlice.setPPS( m_parameterSetManagerDecoder.getFirstPPS() );
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
   cFillSlice.initSlice( m_parameterSetManagerDecoder.getFirstSPS()->getLayerId() );
 #else
@@ -343,5 +343,5 @@
   cFillPic->getSlice(0)->setSPS( m_parameterSetManagerDecoder.getFirstSPS() );
   cFillPic->getSlice(0)->setPPS( m_parameterSetManagerDecoder.getFirstPPS() );
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
   cFillPic->getSlice(0)->initSlice( cFillPic->getLayerId() );
 #else
@@ -434,5 +434,5 @@
 {
   TComPic*&   pcPic         = m_pcPic;
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
   m_apcSlicePilot->initSlice( nalu.m_layerId );
 #else
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 75)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 76)
@@ -188,5 +188,5 @@
   rpcSlice->setSliceBits(0);
   rpcSlice->setPic( pcPic );
-#if SET_SLICE_LAYER_ID
+#if SVC_EXTENSION
   rpcSlice->initSlice( pcPic->getLayerId() );
 #else
@@ -195,7 +195,4 @@
   rpcSlice->setPicOutputFlag( true );
   rpcSlice->setPOC( pocCurr );
-#if SVC_EXTENSION && !SET_SLICE_LAYER_ID
-  rpcSlice->setLayerId( pcPic->getLayerId());
-#endif
   
   // depth computation based on GOP size