Index: /trunk/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg
===================================================================
--- /trunk/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 77)
+++ /trunk/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 78)
@@ -60,6 +60,5 @@
 Frame7    : B    5   4        0.68     0           2                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       0
 Frame8    : B    7   4        0.68     0           2                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       0
-# V1         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v1 : P    0   3        0.370    0           1                1       0                            0                                                      1             -1                 1                  0
+FrameI_v1 : P    0   3        0.442    0           1                1       0                            0                                                      1             -1                 1                  0
 Frame1_v1 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -1                 2                  0 
 Frame2_v1 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -1                 2                  0 
@@ -70,6 +69,5 @@
 Frame7_v1 : B    5   7        0.68     0           3                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       1             -1                 3                  0  
 Frame8_v1 : B    7   7        0.68     0           3                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       1             -1                 3                  0  
-# V2         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV_ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v2 : P    0   3        0.370    0           1                1       0                            0                                                      1             -2                 1                  0  
+FrameI_v2 : P    0   3        0.442    0           1                1       0                            0                                                      1             -2                 1                  0  
 Frame1_v2 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -2                 2                  0  
 Frame2_v2 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -2                 2                  0  
@@ -92,5 +90,5 @@
 HadamardME                : 1                                      # use Hadamard SAD for fractional-sample search
 FEN                       : 1                                      # use fast encoder control
-FDM                       : 0                                      # Fast Decision for Merge RD cost
+FDM                       : 1                                      # Fast Decision for Merge RD cost
 TMVP                      : 1                                      # Enable TMVP
 ECU                       : 0                                      # Early CU setting
@@ -210,5 +208,5 @@
 
 #============ Misc. ================
-SEIpictureDigest          : 1                                      # Control generation of picture_digest SEI messages
-
-
+SEIpictureDigest          : 0                                      # Control generation of picture_digest SEI messages
+
+
Index: /trunk/CommonTestConditionsCfgs/baseCfg_2view.cfg
===================================================================
--- /trunk/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 77)
+++ /trunk/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 78)
@@ -54,6 +54,5 @@
 Frame7    : B    5   4        0.68     0           2                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       0
 Frame8    : B    7   4        0.68     0           2                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       0
-# V1         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v1 : P    0   3        0.370    0           1                1       0                            0                                                      1             -1                 1                  0
+FrameI_v1 : P    0   3        0.442    0           1                1       0                            0                                                      1             -1                 1                  0
 Frame1_v1 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -1                 2                  0 
 Frame2_v1 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -1                 2                  0 
@@ -64,6 +63,5 @@
 Frame7_v1 : B    5   7        0.68     0           3                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       1             -1                 3                  0  
 Frame8_v1 : B    7   7        0.68     0           3                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       1             -1                 3                  0  
-# V2         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV_ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v2 : P    0   3        0.370    0           1                1       0                            0                                                      1             -2                 1                  0  
+FrameI_v2 : P    0   3        0.442    0           1                1       0                            0                                                      1             -2                 1                  0  
 Frame1_v2 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -2                 2                  0  
 Frame2_v2 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -2                 2                  0  
@@ -86,5 +84,5 @@
 HadamardME                : 1                                      # use Hadamard SAD for fractional-sample search
 FEN                       : 1                                      # use fast encoder control
-FDM                       : 0                                      # Fast Decision for Merge RD cost
+FDM                       : 1                                      # Fast Decision for Merge RD cost
 TMVP                      : 1                                      # Enable TMVP
 ECU                       : 0                                      # Early CU setting
@@ -204,5 +202,5 @@
 
 #============ Misc. ================
-SEIpictureDigest          : 1                                      # Control generation of picture_digest SEI messages
-
-
+SEIpictureDigest          : 0                                      # Control generation of picture_digest SEI messages
+
+
Index: /trunk/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg
===================================================================
--- /trunk/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 77)
+++ /trunk/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 78)
@@ -64,6 +64,5 @@
 Frame7    : B    5   4        0.68     0           2                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       0
 Frame8    : B    7   4        0.68     0           2                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       0
-# V1         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v1 : P    0   3        0.370    0           1                1       0                            0                                                      1             -1                 1                  0
+FrameI_v1 : P    0   3        0.442    0           1                1       0                            0                                                      1             -1                 1                  0
 Frame1_v1 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -1                 2                  0 
 Frame2_v1 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -1                 2                  0 
@@ -74,6 +73,5 @@
 Frame7_v1 : B    5   7        0.68     0           3                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       1             -1                 3                  0  
 Frame8_v1 : B    7   7        0.68     0           3                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       1             -1                 3                  0  
-# V2         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV_ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v2 : P    0   3        0.370    0           1                1       0                            0                                                      1             -2                 1                  0  
+FrameI_v2 : P    0   3        0.442    0           1                1       0                            0                                                      1             -2                 1                  0  
 Frame1_v2 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -2                 2                  0  
 Frame2_v2 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -2                 2                  0  
@@ -96,5 +94,5 @@
 HadamardME                : 1                                      # use Hadamard SAD for fractional-sample search
 FEN                       : 1                                      # use fast encoder control
-FDM                       : 0                                      # Fast Decision for Merge RD cost
+FDM                       : 1                                      # Fast Decision for Merge RD cost
 TMVP                      : 1                                      # Enable TMVP
 ECU                       : 0                                      # Early CU setting
@@ -211,8 +209,8 @@
 #========== view synthesis optimization (VSO) ==========
 VSOConfig                 : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][cx2 B(cc1) I(s1.5)] # VSO configuration string
-
+#VSOConfig                    : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) I(s0.5)]                                  #VSO Configuration (2-View) coding order 1 0
 
 #============ Misc. ================
-SEIpictureDigest          : 1                                      # Control generation of picture_digest SEI messages
-
-
+SEIpictureDigest          : 0                                      # Control generation of picture_digest SEI messages
+
+
Index: /trunk/CommonTestConditionsCfgs/baseCfg_3view.cfg
===================================================================
--- /trunk/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 77)
+++ /trunk/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 78)
@@ -56,6 +56,5 @@
 Frame7    : B    5   4        0.68     0           2                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       0
 Frame8    : B    7   4        0.68     0           2                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       0
-# V1         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v1 : P    0   3        0.370    0           1                1       0                            0                                                      1             -1                 1                  0
+FrameI_v1 : P    0   3        0.442    0           1                1       0                            0                                                      1             -1                 1                  0
 Frame1_v1 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -1                 2                  0 
 Frame2_v1 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -1                 2                  0 
@@ -66,6 +65,5 @@
 Frame7_v1 : B    5   7        0.68     0           3                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       1             -1                 3                  0  
 Frame8_v1 : B    7   7        0.68     0           3                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       1             -1                 3                  0  
-# V2         Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV_ref_list_0_pos  IV_ref_list_1_pos
-FrameI_v2 : P    0   3        0.370    0           1                1       0                            0                                                      1             -2                 1                  0  
+FrameI_v2 : P    0   3        0.442    0           1                1       0                            0                                                      1             -2                 1                  0  
 Frame1_v2 : B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -2                 2                  0  
 Frame2_v2 : B    4   5        0.3536   0           3                1       3         -4 -6  4           1       0           4        5         1 1 0 0 1       1             -2                 2                  0  
@@ -88,5 +86,5 @@
 HadamardME                : 1                                      # use Hadamard SAD for fractional-sample search
 FEN                       : 1                                      # use fast encoder control
-FDM                       : 0                                      # Fast Decision for Merge RD cost
+FDM                       : 1                                      # Fast Decision for Merge RD cost
 TMVP                      : 1                                      # Enable TMVP
 ECU                       : 0                                      # Early CU setting
@@ -206,5 +204,5 @@
 
 #============ Misc. ================
-SEIpictureDigest          : 1                                      # Control generation of picture_digest SEI messages
-
-
+SEIpictureDigest          : 0                                      # Control generation of picture_digest SEI messages
+
+
Index: /trunk/cfg/encoder_mvd.cfg
===================================================================
--- /trunk/cfg/encoder_mvd.cfg	(revision 77)
+++ /trunk/cfg/encoder_mvd.cfg	(revision 78)
@@ -1,3 +1,3 @@
-#======== File I/O =====================
+#========== file i/o ==========
 InputFile_0               : org_0.yuv                              # video input file for view 0
 InputFile_1               : org_1.yuv                              # video input file for view 1
@@ -18,32 +18,37 @@
 BitstreamFile             : stream.bit                             # bitstream file
 
-
-#====== General Coding Parameters ======
-NumberOfViews                 : 3           # Number of views to be coded
-CodeDepthMaps                 : 1           # Encode depth maps
-FramesToBeEncoded             : 17          # Number of frames to be coded
-SourceWidth                   : 1024        # Input  frame width
-SourceHeight                  : 768         # Input  frame height
-FrameRate                     : 30          # Frame Rate per second
-FrameSkip                     : 0           # Number of frames to be skipped in input
-InputBitDepth                 : 8           # Input bit-depth
-OutputBitDepth                : 8           # Output bit-depth
-InternalBitDepth              : 8          # Internal bit-depth
-
-#====== Camera Parameters ======
-CameraParameterFile           : ../seq/Balloons/cam_balloons.cfg   # Camera parameter file
-BaseViewCameraNumbers         : 3 1 5                                    # Cameras in coding order [only NumberOfViews values are used]
-CodedCamParsPrecision         : 5                                         # precision for camera parameter coding (max. disparity error = 2^(-x)) [default: 2]
-
-#======== Unit definition ================
-MaxCUWidth                    : 64          # Maximum coding unit width in pixel
-MaxCUHeight                   : 64          # Maximum coding unit height in pixel
-MaxPartitionDepth             :  4          # Maximum coding unit depth
-QuadtreeTULog2MaxSize         : 5                                  # Log2 of maximum transform size for quadtree-based TU coding (2...6)
-QuadtreeTULog2MinSize         : 2                                  # Log2 of minimum transform size for quadtree-based TU coding (2...6)
-QuadtreeTUMaxDepthInter       :  3
-QuadtreeTUMaxDepthIntra       :  3
-
-#======== Coding Structure =============
+#========== general coding parameters ==========
+NumberOfViews             : 3                                      # number of views to be coded
+CodeDepthMaps             : 1                                      # encode depth maps
+FrameSkip                 : 0                                      # number of frames to be skipped at beginning of input sequences
+InputBitDepth             : 8                                      # bit depth of input files
+OutputBitDepth            : 8                                      # bit depth of output files
+InternalBitDepth          : 8                                      # internal bit depth used for coding
+
+CroppingMode              : 0                                      # Cropping mode (0: no cropping, 1:automatic padding, 2: padding, 3:cropping)
+CropLeft                  : 0                                      # Left cropping/padding for cropping mode 3
+CropRight                 : 0                                      # Right cropping/padding for cropping mode 3
+CropTop                   : 0                                      # Top cropping/padding for cropping mode 3
+CropBottom                : 0                                      # Bottom cropping/padding for cropping mode 3
+HorizontalPadding         : 0                                      # horizontal source padding for cropping mode 2
+VerticalPadding           : 0                                      # vertical source padding for cropping mode 2
+
+
+#========== camera parameters ==========
+CameraParameterFile       : cam_pars.txt                           # camera parameter file
+CodedCamParsPrecision     : 5                                      # precision used for coding of camera parameters (in units of 2^(-x) luma samples)
+
+
+#========== coding unit definitions ==========
+MaxCUWidth                : 64                                     # maximum coding unit witdh  (in luma samples) 
+MaxCUHeight               : 64                                     # maximum coding unit height (in luma samples)
+MaxPartitionDepth         : 4                                      # maximum coding unit depth
+QuadtreeTULog2MaxSize     : 5                                      # log2 of maximum transform size
+QuadtreeTULog2MinSize     : 2                                      # log2 of minimum transform size
+QuadtreeTUMaxDepthIntra   : 3                                      # maximum transform tree depth for intra-coded CU's
+QuadtreeTUMaxDepthInter   : 3                                      # maximum transform tree depth for inter-coded CU's
+
+
+#========== coding structure ==========
 IntraPeriod                   : 24          # Period of I-Frame ( -1 = only first)
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CDR, 2:IDR
@@ -58,5 +63,4 @@
 Frame7:     B    5   4        0.68     0           2                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       0
 Frame8:     B    7   4        0.68     0           2                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       0
-# V1        Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV ref_list_0_pos  IV_ref_list_1_pos
 FrameI_v1:  P    0   3        0.442    0           1                1       0                            0                                                      1             -1                 1                  0  
 Frame1_v1:  B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -1                 2                  0  
@@ -68,5 +72,4 @@
 Frame7_v1:  B    5   7        0.68     0           3                0       4         -1 -5  1 3         1       0           1        5         1 0 1 1 1       1             -1                 3                  0  
 Frame8_v1:  B    7   7        0.68     0           3                0       4         -1 -3 -7 1         1       0          -2        5         1 1 1 1 0       1             -1                 3                  0  
-# V2        Type POC QPoffset QPfactor temporal_id #ref_pics_active ref_pic #ref_pics reference pictures predict deltaRIdx-1 deltaRPS #ref_idcs reference idcs  #IV_ref_pics  IV reference pics  IV_ref_list_0_pos  IV_ref_list_1_pos
 FrameI_v2:  P    0   3        0.442    0           1                1       0                            0                                                      1             -2                 1                  0  
 Frame1_v2:  B    8   4        0.442    0           4                1       4         -8 -10 -12 -16     0                                                      1             -2                 2                  0  
@@ -80,41 +83,68 @@
 
 ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+LCModification            : 0                                      # enables signalling of combined reference list derivation
 DisableInter4x4               : 1           # Disable Inter4x4 (1: Disable Inter4x4, 0: Enable Inter4x4)
 
-#=========== Motion Search =============
-FastSearch                    : 1           # 0:Full search  1:EPZS
-SearchRange                   : 96          # (0: Search range is a Full frame)
-BipredSearchRange             : 4           # Search range for bi-prediction refinement
-HadamardME                    : 1           # Use of hadamard measure for fractional ME
-FEN                           : 1           # Fast encoder decision
+
+#========== encoder control /motion search ==========
+FastSearch                : 1                                      # motion search mode (0:Full search, 1:Diamond, 2:PMVFAST)
+SearchRange               : 96                                     # motion search range (in luma samples)
+BipredSearchRange         : 4                                      # motion search range for bi-prediction refinement (in luma samples)
+HadamardME                : 1                                      # use Hadamard SAD for fractional-sample search
+FEN                       : 1                                      # use fast encoder control
 FDM                           : 1           # Fast Decision for Merge RD cost
-
-#============= VSO =============
-VSO                           : 1           # View Synthesis Optimization
-VSOConfig                     : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][cx2 B(cc1) I(s1.5)]  #VSO Configuration (3-View) coding order 1 0 2 oder 1 2 0
-#VSOConfig                    : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) I(s0.5)]                                  #VSO Configuration (2-View) coding order 1 0
-
-#======== Quantization =============
-QP                            : 25 30       # Quantization parameter(0-51), second QP for Depth
-MaxDeltaQP                    : 0           # CU-based multi-QP optimization
-MaxCuDQPDepth                 : 0           # Max depth of a minimum CuDQP for sub-LCU-level delta QP
-DeltaQpRD                     : 0           # Slice-based multi-QP optimization
-RDOQ                          : 1  1        # RDOQ
+TMVP                      : 1                                      # Enable TMVP
+ECU                       : 0                                      # Early CU setting
+CFM                       : 0                                      # Cbf fast mode setting
+SBACRD                    : 1                                      # SBAC based RD estimation
+ASR                       : 0                                      # adaptive motion search range
+
+
+#========== quantization ==========
+DeltaQpRD                 : 0                                      # maximum delta QP offset for a slice
+MaxDeltaQP                : 0                                      # maximum delta QP offset for a block
+MaxCuDQPDepth             : 0                                      # max depth of a minimum CuDQP for sub-LCU-level delta QP
+RDOQ                      : 1 1                                    # use rate-distortion optimized quantization (RDOQ)
 ChromaQpOffset                : 0           # ChromaQPOffset
 ChromaQpOffset2nd             : 0           # ChromaQPOffset2nd
-
-#=========== Entropy Coding ============
-
-#=========== Deblock Filter ============
+AdaptiveQpSelection       : 0                                      # AdaptiveQpSelection
+AdaptiveQP                : 0                                      # QP adaptation based on a psycho-visual model
+MaxQPAdaptationRange      : 6                                      # QP adaptation range
+LambdaModifier0           : 1.0                                    # Lambda modifier for temporal layer 0
+LambdaModifier1           : 1.0                                    # Lambda modifier for temporal layer 1
+LambdaModifier2           : 1.0                                    # Lambda modifier for temporal layer 2
+LambdaModifier3           : 1.0                                    # Lambda modifier for temporal layer 3
+
+
+#=========== Quantization Matrix =================
+ScalingList               : 0                                      # ScalingList 0 : off, 1 : default, 2 : file read
+# ScalingListFile         :                                        # Scaling List file name. If file is not exist, use Default Matrix.
+
+
+#============ Lossless ================
+LosslessCuEnabled         : 0                                      # 1: Set "qpprime_y_zero_transquant_bypass_flag=1" and enable the lossless mode as well as the RD-based mode selection process.
+
+
+#========== slices ==========
+SliceGranularity          : 0                                      # Slice granularity relative the LCU size
+SliceMode                 : 0                                      # slice mode (0:off, 1:max # of LCUs, 2:max # of bytes)
+SliceArgument             : 1500                                   # slice argument (SliceMode1:max # of LCUs, SliceMode2: max # of bytes)
+EntropySliceMode          : 0                                      # entropy slices (0:off, 1:max # of LCUs, 2:max # of bins)
+EntropySliceArgument      : 180000                                 # entropy slice argument (EntropySliceMode1:max # of LCUs, EntropySliceMode2:max # of bins)
+LFCrossSliceBoundaryFlag  : 1                                      # loop-filtering across slice boundaries
+
+
+#========== deblocking ==========
 DeblockingFilterControlPresent: 0           # Dbl control params present (0=not present, 1=present)
 LoopFilterOffsetInAPS         : 0           # Dbl params in APS or SliceHeader (0=SliceHeader, 1=APS)
-LoopFilterDisable             : 0 1          # Disable deblocking filter in slice header (0=Filter, 1=No Filter)
+LoopFilterDisable              : 0 1                               # disable deblocking filter
 LoopFilterBetaOffset_div2     : 0           # Range: -13 ~ 13
 LoopFilterTcOffset_div2       : 0           # Range: -13 ~ 13
 
-#=========== Coding Tools =================
+
+#========== coding tools ==========
+ALFEncodePassReduction         : 0                                 # ALF encoding (0:original 16-pass, 1:one-pass, 2:two-pass)
 SAO                           : 1 0         # Sample adaptive offset  (0: OFF, 1: ON)
-ALF                           : 0           # Adaptive loop filter  (0: OFF, 1: ON)
-ALFEncodePassReduction        : 0           # Reduce ALF encoding passes (0:Original 16-pass, 1: 1-pass, 2: 2-pass encoding)
+ALF                            : 0 0                               # Adaptive loop filter  (0: OFF, 1: ON)
 LMChroma                      : 0           # Chroma from luma intra prediction mode (0: OFF, 1: ON)
 NSQT                          : 0           # Non-square transforms (0: OFF, 1: ON)
@@ -123,37 +153,12 @@
 ALFParamInSlice               : 0           # ALF params in SliceHeader or APS (0=APS, 1=SliceHeader)
 ALFPicBasedEncode             : 1           # ALF LCU-based or picture-based encoding (0: LCU-based, 1: Picture-based)  
+MaxNumOffsetsPerPic            : 2048                              # default
 SAOInterleaving               : 0           # SAO interleaving flag (0: SAO parameter in APS, 1: SAO parameter in slice data) 
-
-#========== Depth Coding Tools ==========
-DMM                           : 1           # use depth intra modes (wedgelets)
-MVI                           : 1
-
-#====== multiview mv/res prediction ======
-PredDepthMapGen               : 1           # generation of predicted depth maps (0:off, 1:using coded MVs, 2:using coded depth, 3:coded MVS for non-random-access, coded depth for random access)
-MultiviewMvPred               : 7           # usage for predicted depth maps (sum of the following: 1:inter-view, 2:inter, 4:merge)
-MultiviewMvRegMode            : 1           # regularization (using original depth maps) for inter-view motion estimation
-MultiviewMvRegLambdaScale     : 1.0         # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred              : 1           # multiview residual prediction
-
-#============ Slices ================
-SliceGranularity         : 0                # Slice granularity relative the LCU size
-SliceMode                : 0                # 0: Disable all slice options.
-                                            # 1: Enforce maximum number of LCU in an slice,
-                                            # 2: Enforce maximum number of bytes in an 'slice'
-                                            # 3: Enforce maximum number of tiles in a slice
-SliceArgument            : 1500             # Argument for 'SliceMode'.
-                                            # If SliceMode==1 it represents max. SliceGranularity-sized blocks per slice.
-                                            # If SliceMode==2 it represents max. bytes per slice.
-                                            # If SliceMode==3 it represents max. tiles per slice.
-
-LFCrossSliceBoundaryFlag : 1                # In-loop filtering, including ALF and DB, is across or not across slice boundary.
-                                            # 0:not across, 1: across
-
-EntropySliceMode         : 0                # 0: Disable all entropy slice options.
-                                            # 1: Enforce maximum number of LCU in an entropy slice,
-                                            # 2: Enforce maximum number of bins/bits in an 'entropy slice'
-EntropySliceArgument     : 180000           # Argument for 'EntropySliceMode'.
-                                            # If EntropySliceMode==1 it represents max. SliceGranularity-sized blocks per slice.
-                                            # If EntropySliceMode==2 it represents max. bins per entropy slice.
+ConstrainedIntraPred           : 0                                 # Constrained Intra Prediction
+weighted_pred_flag             : 0                                 # weighted prediction flag (P-Slices)
+weighted_bipred_idc            : 0                                 # weighted bipred idc (B-Slices)
+SignHideFlag                   : 1                                 # sign hiding
+SignHideThreshold              : 4                                 # sign hiding threshold
+
 
 #============ PCM ================
@@ -164,40 +169,47 @@
 PCMFilterDisableFlag                : 0                # 0: Enable loop filtering on I_PCM samples. 1: Disable loop filtering on I_PCM samples.
 
+
 #============ Tiles ================
-TileInfoPresentFlag                 : 1                # 0: tiles parameters are NOT present in the PPS
-                                                       # 1: tiles parameters are present in the PPS 
-UniformSpacingIdc                   : 0                # 0: the column boundaries are indicated by ColumnWidth array, the row boundaries are indicated by RowHeight array
-                                                       # 1: the column and row boundaries are distributed uniformly
+TileInfoPresentFlag            : 1                                 # 0: tiles parameters are NOT present in the PPS, 1: tiles parameters are present in the PPS 
+UniformSpacingIdc              : 0                                 # 0: the column boundaries are indicated by ColumnWidth array, the row boundaries are indicated by RowHeight array, 1: the column and row boundaries are distributed uniformly
 NumTileColumnsMinus1                : 0                # Number of columns in a picture minus 1
 ColumnWidthArray                    : 2 3              # Array containing ColumnWidth values in units of LCU (from left to right in picture)   
 NumTileRowsMinus1                   : 0                # Number of rows in a picture minus 1
 RowHeightArray                      : 2                # Array containing RowHeight values in units of LCU (from top to bottom in picture)
-
-TileLocationInSliceHeaderFlag       : 0                # If TileBoundaryIndependenceIdc==0 flag is ignored.
-                                                       # 1: Enable writing tile location information to slice header.
-                                                       # 0: Disable writing tile location information to slice header.
-TileMarkerFlag                    : 1                  # If TileBoundaryIndependenceIdc==0 flag is ignored.
-                                                       # 1: Enable writing tile markers.
-                                                       # 0: Disable writing tile markers.
-MaxTileMarkerEntryPoints          : 4                  # Maximum number of uniformly-spaced tile entry points (using tile markers). 
-                                                       # Default=4. If number of tiles < MaxTileMarkerEntryPoints then all tiles have entry points.
-TileControlPresentFlag            : 1                  # 0: tiles behavior control parameters are NOT present in the PPS
-                                                       # 1: tiles behavior control parameters are present in the PPS
-LFCrossTileBoundaryFlag           : 1                  # In-loop filtering is across or not across tile boundary.
-                                                       # 0:not across, 1: across                                                       
+TileLocationInSliceHeaderFlag  : 0                                 # If TileBoundaryIndependenceIdc==0 flag is ignored, 1: Enable writing tile location information to slice header, 0: Disable writing tile location information to slice header.
+TileMarkerFlag                 : 1                                 # If TileBoundaryIndependenceIdc==0 flag is ignored, 1: Enable writing tile markers, 0: Disable writing tile markers.
+MaxTileMarkerEntryPoints       : 4                                 # Maximum number of uniformly-spaced tile entry points (using tile markers). Default=4. If number of tiles < MaxTileMarkerEntryPoints then all tiles have entry points.
+TileControlPresentFlag         : 1                                 # 0: tiles behavior control parameters are NOT present in the PPS,  1: tiles behavior control parameters are present in the PPS
+LFCrossTileBoundaryFlag        : 1                                 # In-loop filtering is across or not across tile boundary.  0:not across, 1: across                                                       
+
 
 #============ WaveFront ================
-WaveFrontSynchro                    : 0                # 0:  No WaveFront synchronisation (WaveFrontSubstreams must be 1 in this case).
-                                                       # >0: WaveFront synchronises with the LCU above and to the right by this many LCUs.
-WaveFrontFlush                      : 0                # 0: No CABAC resets are performed.
-                                                       # 1: A CABAC reset is performed at the end of each LCU line.
+WaveFrontSynchro               : 0                                 # 0:  No WaveFront synchronisation (WaveFrontSubstreams must be 1 in this case), >0: WaveFront synchronises with the LCU above and to the right by this many LCUs.
+WaveFrontFlush                 : 0                                 # 0: No CABAC resets are performed, 1: A CABAC reset is performed at the end of each LCU line.
 WaveFrontSubstreams                 : 1                # >0: This many substreams per slice (or per tile if TileBoundaryIndependenceIdc=1) will be produced.
 
-#=========== Quantization Matrix =================
-ScalingList                   : 0                      # ScalingList 0 : off, 1 : default, 2 : file read
-ScalingListFile               : scaling_list.txt       # Scaling List file name. If file is not exist, use Default Matrix.
-
-#============ Lossless ================
-LosslessCuEnabled                   : 0                # 1: Set "qpprime_y_zero_transquant_bypass_flag=1" and enable the lossless mode as well as the RD-based mode selection process.
+
+#========== multiview coding tools ==========
+PredDepthMapGen           : 1                                      # generation of prediction depth maps (0:off, 1:using coded motion data, 2:using coded depth maps)
+MultiviewMvPred           : 7                                      # usage of prediction depth maps (0:off, 1:for interview, 2:for inter, 4:for merge, X:bit-wise combinations)
+MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
+MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
+MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+InterViewSkip             : 0                                      # interview SKIP mode
+InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
+
+
+#========== depth coding tools ==========
+DMM                       : 1                                      # use depth intra modes (wedgelets)
+MVI                       : 1                                      # motion parameter inheritance
+VSO                       : 1                                      # use of view synthesis optimization for depth coding
+
+
+#========== view synthesis optimization (VSO) ==========
+VSOConfig                 : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][cx2 B(cc1) I(s1.5)] # VSO configuration string
+
+
+#============ Misc. ================
+SEIpictureDigest          : 0                                      # Control generation of picture_digest SEI messages
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###